/*
 * This file is a part of CMSLU -- Content Management System like Unix
 * and is not publicly distributed
 * 
 * Copyright (c) 2008-2009, Tomasz Sowa
 * All rights reserved.
 * 
 */
 
#include "content.h"
#include "../core/request.h"
#include "../core/error.h"
#include "../core/db.h"
#include "../core/mount.h"
#include "../core/data.h"


bool Content::FunCreateThreadCheckAccess()
{
	if( !request.CanCreateThread() )
	{
		request.status = Error::permision_denied;
		return false;
	}


return true;
}



void Content::PostFunCreateThread()
{
	if( !FunCreateThreadCheckAccess() )
		return;

	if( !CheckRebus() )
	{
		request.status = Error::rebus_bad_answer;
		request.PostVar("url", request.item.url);
		request.PostVar("subject", request.item.subject);
		request.PostVar("content", request.item.content);
		SetUser(request.item);

		return;
	}

	request.post_table.insert( std::make_pair(std::string("url"), std::string()) ); // !! tymczasowo, zrobic aby mkdir i emacs nie rzucaly wyjatkiem gdy nie ma url zdefiniowanego

	request.thread.parent_id = request.dir_table.back()->id;
	PostFunMkdir(true, 0777); // !! tymczasowo 777 aby wszyscy mogli wysylac posty
	
	if( request.session->done_status == Error::ok )
	{
		PostFunEmacs();

		if( request.session->done_status == Error::ok )
		{
			request.thread.dir_id        = request.dir_table.back()->id;
			request.thread.closed        = false;
			request.thread.items         = 1;
			request.thread.last_item     = request.item; // set by PostFunEmacs()

			request.session->done_status = db.AddThread(request.thread);
		}

		
		if( request.session->done_status == Error::ok )
		{
			request.session->done = Done::added_thread;
			RedirectTo(*request.dir_table.back());
		}
		
	}
	
	
}







void Content::FunCreateThread()
{
	FunCreateThreadCheckAccess();
}




